package ui;

import java.awt.event.*;

import javax.swing.*;

import model.BambooModel;

import controller.BambooController;

@SuppressWarnings("serial")
public class CommonButtonPanel extends JPanel {
	private JButton leftButton;
	private JButton reverseButton;
	private JButton rotateButton;

	public CommonButtonPanel(final BambooController controller,
			final BambooModel model) {
//		this.setPreferredSize(new Dimension(40, 20));
		// C[{^̐ݒ
//		leftButton = new JButton("");
		leftButton = new JButton("-");
		leftButton.setFocusable(false);
		leftButton.setEnabled(false);
		//leftButton.setSize(10, 10);
		leftButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.decreaseLayer();
			}
		});
		add(leftButton);

		// EC[{^̐ݒ
		//JButton rightButton = new JButton("");
		JButton rightButton = new JButton("+");
		rightButton.setFocusable(false);
		rightButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.increaseLayer();
			}
		});
		add(rightButton);

		// C[x
		LayerLabel layerLabel = new LayerLabel("0");
		model.addLayerListener(layerLabel);
		add(layerLabel);

		// ]{^
		reverseButton = new JButton("");
		reverseButton.setFocusable(false);
		reverseButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.reverse();
			}
		});
		add(reverseButton);

		// ]{^
		rotateButton = new JButton("");
		rotateButton.setFocusable(false);
		rotateButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.rotate();
			}
		});
		add(rotateButton);
		if (controller.getRowCount() != controller.getColumnCount())
			rotateButton.setEnabled(false);
	}

	public void enableLeftButton() {
		leftButton.setEnabled(true);
	}

	public void disableLeftButton() {
		leftButton.setEnabled(false);
	}

	public JButton getReverseButton() {
		return reverseButton;
	}
	
	public JButton getRotateButton() {
		return rotateButton;
	}
}
